/*
 * Florida Tech, CSE3001.  Compiler project based on "Modern Compiler
 * Implementation in Java" by Andrew W. Appel.
 */

/*
 * The entire "assem" package is provided to the student to be used as
 * is in the completion of the "Program: Instruction Selection", Chapter 9
 * page 216.
 */

/*
 * The "assem" package provides abstract assembly language instructions;
 * these instructions have no register assignments.
 */

package assem;

import temp.Temp;
import temp.Label;
import temp.TempMap;

import java.util.List;


public abstract class Instr {
   public final String assem;
   public abstract List use();    // List of temp.Temp
   public abstract List def();    // List of temp.Temp
   public abstract List jumps();  // List of temp.Label

   protected Instr (String a) { assem=a; }
   public String toString () { return assem; }

   public String format (TempMap map) {
      final List dst = def();
      final List src = use();
      final List jump = jumps();
      final StringBuffer s = new StringBuffer();
      final int len = assem.length();
      for(int i=0; i<len; i++)
	 if(assem.charAt(i)=='`') {
	    int n;
	    switch(assem.charAt(++i)) {
	    case 's':
	       n = Character.digit(assem.charAt(++i),10);
	       s.append(map.tempMap ((Temp) src.get(n)));
	       break;

	    case 'd':
	       n = Character.digit(assem.charAt(++i),10);
	       s.append(map.tempMap((Temp) dst.get(n)));
	       break;

	    case 'j':
	       n = Character.digit(assem.charAt(++i),10);
	       s.append((Label)jump.get(n)).toString();
	       break;

	    case '`':
	       s.append('`'); 
	       break;

	    default:
	       throw new RuntimeException ("bad Assem format");
	    }
	 } else {
	    s.append(assem.charAt(i));
	 }
      return s.toString();
   }
}
