package symbol;

public class Name extends Type {
   public final String name;
   private Type binding;

   public Name (String n) {name=n;}

   // Bind separately for mutually recursive type definitions
   public void bind (Type t) {binding = t;}

   public boolean isLoop() {
      final Type b = binding;  // remember original binding
      binding=null;
      final boolean any =
	 b==null || (b instanceof Name && ((Name)b).isLoop());
      binding=b;   // restore original
      return any;
   }
     
  public Type actual() { return binding.actual(); }
  public boolean coerceTo(Type t) { return this.actual().coerceTo(t);  }

  public String toString() 
  { return "name->" + name; }
}
