package symbol;

class ScopeTest {
    static SymbolTable st = new SymbolTable();
    static int indent = 0;
    
    public static void main(String args[]) {
        begin();
        set("a", 1);
        set("b", 2);
        begin();
        set("a", 3);
        set("c", 4);
        set("a", 4);
        get("a");
        get("b");
        end();
        
        get("a");
        get("b");
        get("c");
        end();

        get("b");
    }

    static void begin() 
    {
        st.beginScope();
        p("beginScope");
        indent++;
    }

    static void end() 
    {
        st.endScope();
        indent--;
        p("endScope");
    }

    static void set(String key, int val)
    {
        p("SET " + key + "=" + val);
        st.put(key, new Integer(val));
    }

    static void get(String key) 
    {
        p(key + "=" + st.get(key));
    }

    static void p(String s) 
    {
        System.out.println(spaces(2*indent) + s);
    }

    static String spaces(int n) 
    {
        String s = "";
        for(int i=0; i<n; i++)
            s+=" ";
        return s;
    }
}
