package translate;

import temp.Temp;
import temp.Label;

import tree.CJUMP;
import tree.CONST;
import tree.ESEQ;
import tree.EXP;
import tree.JUMP;
import tree.LABEL;
import tree.MOVE;
import tree.SEQ;
import tree.TEMP;

public class Cx extends Exp 
{
  int op;
  tree.Exp lhs;
  tree.Exp rhs;

  Cx(int o, tree.Exp l, tree.Exp r)
  { op = o; lhs = l; rhs = r; }

  // returns 1 if true, 0 if false
  tree.Exp unEx()
  { return unEx(new CONST(1), new CONST(0)); }

  tree.Stm unNx() 
  { return unNx(new Label(), new Label()); }

  // used for if-then loops
  tree.Stm unNx(tree.Stm t)
  {
    Label lt = new Label("IFt");
    Label ld = new Label("IFd");
    /*
      format is:
      CJUMP(op, lhs, rhs, Label IFt, Label IFd)
      LABEL IFt
      code_true
      LABEL IFd
     */
    return new SEQ(new CJUMP(op, lhs, rhs, lt, ld),
                   new SEQ(new SEQ(new LABEL(lt), t),
                           new LABEL(ld)));
  }
  
  // jumps to the appropriate label
  tree.Stm unNx(Label lt, Label lf) 
  { return new CJUMP(op, lhs, rhs, lt, lf); }
  
  // Execs ct if tru, cf if false
  tree.Exp unEx(tree.Exp ct, tree.Exp cf) {
    Label lt = new Label("IFt");
    Label lf = new Label("IFf");
    Label ld = new Label("IFd");
    TEMP tmp = new TEMP(new Temp("IFtmp"));

    /*
      format is:
        CJUMP(op, lhs, rhs)

        LABEL IFt
        TEMP t = code_true
        JUMP IFd

        LABEL IFf
        TEMP f = code_false
        JUMP IFd

        LABEL IFd
        return TEMP t
    */
    CJUMP cjump = new CJUMP(op, lhs, rhs, lt, lf);

    SEQ   seqt = new SEQ(new SEQ(new LABEL(lt),      // LABEL IFt
                                 new MOVE(tmp, ct)), // TEMP t = code_true
                         new JUMP(ld));              // JUMP IFd

    SEQ   seqf = new SEQ(new SEQ(new LABEL(lf),      // LABEL IFf
                                 new MOVE(tmp, cf)), // TEMP f = code_true
                         new JUMP(ld));              // JUMP IFd

    // combine the loop
    SEQ seq = new SEQ(new SEQ(cjump, new SEQ(seqt, seqf)),
                      new LABEL(ld));

    // exec loop and return temp
    return new ESEQ(seq, tmp);
  }
}
